#include <iostream>   
#include <sstream>   
#include <cstdio>   
#include <cstdlib>   
#include <cmath>   
#include <memory>   
#include <cctype>   
#include <string>   
#include <vector>   
#include <list>   
#include <queue>   
#include <deque>   
#include <stack>   
#include <map>   
#include <set>   
#include <algorithm>   
using namespace std;  
   
#define FOR(i,a,b) for(int (i) = (a); (i) < (b); ++(i))  
#define RFOR(i,a,b) for(int (i) = (a)-1; (i) >= (b); --(i))  
#define CLEAR(a) memset((a),0,sizeof(a))  
#define INF 1000000000  
#define PB push_back  
#define ALL(c) (c).begin(), (c).end()  
#define pi 2*acos(0.0)  
#define SQR(a) (a)*(a)  
#define MP make_pair  
#define MAX 1024
#define MOD 1000000007
   
typedef long long Int; 

int T, n;
int A[MAX];
int C[MAX][MAX];

int main()
{

	// precalculating C(n, k)
	FOR (i,0,MAX)
		C[i][0] = 1;
	FOR (i,1,MAX)
		FOR (j,0,i+1)
			C[i][j] = (C[i-1][j] + C[i-1][j-1]) % MOD;


	// reading the number of test cases
	cin >> T;
	// iterating through all test cases
	FOR (t,0,T)
	{
		// reading n
		cin >> n;
		// reading all colors of the cards
		FOR (i,0,n)
			scanf("%d", &A[i]);
		Int res = 0;

		// calculating the result
		FOR (i,0,n)
			if (i < (n-i))
			{
				res += C[n][i];
				res %= MOD;
			}
		// the result output
		cout << res << endl;

	}
	return 0;
} 
 
 